Index: projectionDesigner/trunk/projdesigner/ui_qdesignviewwindow.h
===================================================================
--- projectionDesigner/trunk/projdesigner/ui_qdesignviewwindow.h	(revision 4)
+++ projectionDesigner/trunk/projdesigner/ui_qdesignviewwindow.h	(revision 48)
@@ -1,9 +1,9 @@
 /********************************************************************************
-** Form generated from reading ui file 'qdesignviewwindow.ui'
+** Form generated from reading UI file 'qdesignviewwindow.ui'
 **
-** Created: Wed 2. Sep 15:07:30 2009
-**      by: Qt User Interface Compiler version 4.5.1
+** Created: Wed 19. May 11:06:36 2010
+**      by: Qt User Interface Compiler version 4.6.2
 **
-** WARNING! All changes made in this file will be lost when recompiling ui file!
+** WARNING! All changes made in this file will be lost when recompiling UI file!
 ********************************************************************************/
 
@@ -76,45 +76,45 @@
         QDesignViewWindow->resize(960, 700);
         QIcon icon;
-        icon.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/projDesigner.png")), QIcon::Normal, QIcon::Off);
+        icon.addFile(QString::fromUtf8(":/new/prefix1/Resources/projDesigner.png"), QSize(), QIcon::Normal, QIcon::Off);
         QDesignViewWindow->setWindowIcon(icon);
         actionFileNew = new QAction(QDesignViewWindow);
         actionFileNew->setObjectName(QString::fromUtf8("actionFileNew"));
         QIcon icon1;
-        icon1.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/new.png")), QIcon::Normal, QIcon::Off);
+        icon1.addFile(QString::fromUtf8(":/new/prefix1/Resources/new.png"), QSize(), QIcon::Normal, QIcon::Off);
         actionFileNew->setIcon(icon1);
         actionFileOpen = new QAction(QDesignViewWindow);
         actionFileOpen->setObjectName(QString::fromUtf8("actionFileOpen"));
         QIcon icon2;
-        icon2.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/open.png")), QIcon::Normal, QIcon::Off);
+        icon2.addFile(QString::fromUtf8(":/new/prefix1/Resources/open.png"), QSize(), QIcon::Normal, QIcon::Off);
         actionFileOpen->setIcon(icon2);
         actionFileSave = new QAction(QDesignViewWindow);
         actionFileSave->setObjectName(QString::fromUtf8("actionFileSave"));
         QIcon icon3;
-        icon3.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/save.png")), QIcon::Normal, QIcon::Off);
+        icon3.addFile(QString::fromUtf8(":/new/prefix1/Resources/save.png"), QSize(), QIcon::Normal, QIcon::Off);
         actionFileSave->setIcon(icon3);
         actionFileSaveAs = new QAction(QDesignViewWindow);
         actionFileSaveAs->setObjectName(QString::fromUtf8("actionFileSaveAs"));
         QIcon icon4;
-        icon4.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/saveAs.png")), QIcon::Normal, QIcon::Off);
+        icon4.addFile(QString::fromUtf8(":/new/prefix1/Resources/saveAs.png"), QSize(), QIcon::Normal, QIcon::Off);
         actionFileSaveAs->setIcon(icon4);
         actionFileSyncClients = new QAction(QDesignViewWindow);
         actionFileSyncClients->setObjectName(QString::fromUtf8("actionFileSyncClients"));
         QIcon icon5;
-        icon5.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/sync.png")), QIcon::Normal, QIcon::Off);
+        icon5.addFile(QString::fromUtf8(":/new/prefix1/Resources/sync.png"), QSize(), QIcon::Normal, QIcon::Off);
         actionFileSyncClients->setIcon(icon5);
         actionFileExit = new QAction(QDesignViewWindow);
         actionFileExit->setObjectName(QString::fromUtf8("actionFileExit"));
         QIcon icon6;
-        icon6.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/exit.png")), QIcon::Normal, QIcon::Off);
+        icon6.addFile(QString::fromUtf8(":/new/prefix1/Resources/exit.png"), QSize(), QIcon::Normal, QIcon::Off);
         actionFileExit->setIcon(icon6);
         actionFileExitAll = new QAction(QDesignViewWindow);
         actionFileExitAll->setObjectName(QString::fromUtf8("actionFileExitAll"));
         QIcon icon7;
-        icon7.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/exitAll.png")), QIcon::Normal, QIcon::Off);
+        icon7.addFile(QString::fromUtf8(":/new/prefix1/Resources/exitAll.png"), QSize(), QIcon::Normal, QIcon::Off);
         actionFileExitAll->setIcon(icon7);
         actionEditDesignDistortionMap = new QAction(QDesignViewWindow);
         actionEditDesignDistortionMap->setObjectName(QString::fromUtf8("actionEditDesignDistortionMap"));
         QIcon icon8;
-        icon8.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/distortionMode.png")), QIcon::Normal, QIcon::Off);
+        icon8.addFile(QString::fromUtf8(":/new/prefix1/Resources/distortionMode.png"), QSize(), QIcon::Normal, QIcon::Off);
         actionEditDesignDistortionMap->setIcon(icon8);
         actionEditDesignDistortionMap->setShortcutContext(Qt::ApplicationShortcut);
@@ -122,5 +122,5 @@
         actionEditDesignBlendMap->setObjectName(QString::fromUtf8("actionEditDesignBlendMap"));
         QIcon icon9;
-        icon9.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/blendMode.png")), QIcon::Normal, QIcon::Off);
+        icon9.addFile(QString::fromUtf8(":/new/prefix1/Resources/blendMode.png"), QSize(), QIcon::Normal, QIcon::Off);
         actionEditDesignBlendMap->setIcon(icon9);
         actionEditDesignBlendMap->setShortcutContext(Qt::ApplicationShortcut);
@@ -128,5 +128,5 @@
         actionEditPreference->setObjectName(QString::fromUtf8("actionEditPreference"));
         QIcon icon10;
-        icon10.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/settings.png")), QIcon::Normal, QIcon::Off);
+        icon10.addFile(QString::fromUtf8(":/new/prefix1/Resources/settings.png"), QSize(), QIcon::Normal, QIcon::Off);
         actionEditPreference->setIcon(icon10);
         actionEditPreference->setShortcutContext(Qt::ApplicationShortcut);
@@ -160,5 +160,5 @@
         actionHelpHelp->setObjectName(QString::fromUtf8("actionHelpHelp"));
         QIcon icon11;
-        icon11.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/help.png")), QIcon::Normal, QIcon::Off);
+        icon11.addFile(QString::fromUtf8(":/new/prefix1/Resources/help.png"), QSize(), QIcon::Normal, QIcon::Off);
         actionHelpHelp->setIcon(icon11);
         actionHelpAbout = new QAction(QDesignViewWindow);
@@ -168,15 +168,15 @@
         actionFileExportDataset->setObjectName(QString::fromUtf8("actionFileExportDataset"));
         QIcon icon12;
-        icon12.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/export.png")), QIcon::Normal, QIcon::Off);
+        icon12.addFile(QString::fromUtf8(":/new/prefix1/Resources/export.png"), QSize(), QIcon::Normal, QIcon::Off);
         actionFileExportDataset->setIcon(icon12);
         actionHelpPlugins = new QAction(QDesignViewWindow);
         actionHelpPlugins->setObjectName(QString::fromUtf8("actionHelpPlugins"));
         QIcon icon13;
-        icon13.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/plugins.png")), QIcon::Normal, QIcon::Off);
+        icon13.addFile(QString::fromUtf8(":/new/prefix1/Resources/plugins.png"), QSize(), QIcon::Normal, QIcon::Off);
         actionHelpPlugins->setIcon(icon13);
         actionHelpAbout_Qt = new QAction(QDesignViewWindow);
         actionHelpAbout_Qt->setObjectName(QString::fromUtf8("actionHelpAbout_Qt"));
         QIcon icon14;
-        icon14.addPixmap(QPixmap(QString::fromUtf8(":/new/prefix1/Resources/aboutQt.png")), QIcon::Normal, QIcon::Off);
+        icon14.addFile(QString::fromUtf8(":/new/prefix1/Resources/aboutQt.png"), QSize(), QIcon::Normal, QIcon::Off);
         actionHelpAbout_Qt->setIcon(icon14);
         centralWidget = new QWidget(QDesignViewWindow);
@@ -186,5 +186,5 @@
         hboxLayout->setSpacing(6);
 #endif
-        hboxLayout->setMargin(0);
+        hboxLayout->setContentsMargins(0, 0, 0, 0);
         hboxLayout->setObjectName(QString::fromUtf8("hboxLayout"));
         splitter = new QSplitter(centralWidget);