Index: /experimental/TerrainTest/Plugins terrainmod/Plugins terrainmod.vcproj
===================================================================
--- /experimental/TerrainTest/Plugins terrainmod/Plugins terrainmod.vcproj	(revision 253)
+++ /experimental/TerrainTest/Plugins terrainmod/Plugins terrainmod.vcproj	(revision 253)
@@ -0,0 +1,213 @@
+<?xml version="1.0" encoding="Windows-1252"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="9,00"
+	Name="Plugins terrainmod"
+	ProjectGUID="{59A20266-19E6-4ABD-A43A-6485BA7C1537}"
+	RootNamespace="Pluginsterrainmod"
+	TargetFrameworkVersion="131072"
+	>
+	<Platforms>
+		<Platform
+			Name="Win32"
+		/>
+	</Platforms>
+	<ToolFiles>
+	</ToolFiles>
+	<Configurations>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory="$(SolutionDir)$(ConfigurationName)"
+			IntermediateDirectory="$(ConfigurationName)"
+			ConfigurationType="2"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="0"
+				AdditionalIncludeDirectories="$(OSG_ROOT)/include"
+				PreprocessorDefinitions="WIN32;_WINDOWS;_DEBUG;_SCL_SECURE_NO_WARNINGS;_CRT_SECURE_NO_DEPRECATE;osgdb_terrainmod_EXPORTS"
+				MinimalRebuild="true"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="3"
+				EnableFunctionLevelLinking="false"
+				WarningLevel="4"
+				DebugInformationFormat="3"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLinkerTool"
+				LinkLibraryDependencies="false"
+				AdditionalDependencies="osgDBd.lib osgd.lib OpenThreadsd.lib"
+				OutputFile="$(OSG_ROOT)\bin\osgPlugins-2.9.11\osgdb_terrainmodd.dll"
+				Version="0.0"
+				LinkIncremental="1"
+				AdditionalLibraryDirectories="$(OSG_ROOT)/lib"
+				GenerateDebugInformation="true"
+				TargetMachine="1"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCManifestTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCAppVerifierTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
+		</Configuration>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory="$(SolutionDir)$(ConfigurationName)"
+			IntermediateDirectory="$(ConfigurationName)"
+			ConfigurationType="2"
+			CharacterSet="2"
+			WholeProgramOptimization="1"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="2"
+				EnableIntrinsicFunctions="true"
+				AdditionalIncludeDirectories="$(OSG_ROOT)/include"
+				PreprocessorDefinitions="WIN32;_WINDOWS;NDEBUG;_SCL_SECURE_NO_WARNINGS;_CRT_SECURE_NO_DEPRECATE;osgdb_terrainmods_EXPORTS"
+				RuntimeLibrary="2"
+				EnableFunctionLevelLinking="false"
+				WarningLevel="3"
+				DebugInformationFormat="3"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLinkerTool"
+				LinkLibraryDependencies="false"
+				AdditionalDependencies="osgDB.lib osg.lib OpenThreads.lib"
+				OutputFile="$(OSG_ROOT)\bin\osgPlugins-2.9.11\osgdb_terrainmod.dll"
+				Version="0.0"
+				LinkIncremental="1"
+				AdditionalLibraryDirectories="$(OSG_ROOT)/lib"
+				GenerateDebugInformation="true"
+				OptimizeReferences="2"
+				EnableCOMDATFolding="2"
+				TargetMachine="1"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCManifestTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCAppVerifierTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter
+			Name="Quelldateien"
+			Filter="cpp;c;cc;cxx;def;odl;idl;hpj;bat;asm;asmx"
+			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}"
+			>
+			<File
+				RelativePath="..\ModificationVisitor.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\ReaderWriterTerrainMod.cpp"
+				>
+			</File>
+		</Filter>
+		<Filter
+			Name="Headerdateien"
+			Filter="h;hpp;hxx;hm;inl;inc;xsd"
+			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}"
+			>
+			<File
+				RelativePath="..\ModificationVisitor.h"
+				>
+			</File>
+			<File
+				RelativePath="..\ReaderWriterTerrainMod.h"
+				>
+			</File>
+		</Filter>
+		<Filter
+			Name="Ressourcendateien"
+			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe;resx;tiff;tif;png;wav"
+			UniqueIdentifier="{67DA6AB6-F800-4c08-8B7A-83BB121AAD01}"
+			>
+		</Filter>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>
Index: /experimental/TerrainTest/ReaderWriterTerrainMod.cpp
===================================================================
--- /experimental/TerrainTest/ReaderWriterTerrainMod.cpp	(revision 252)
+++ /experimental/TerrainTest/ReaderWriterTerrainMod.cpp	(revision 253)
@@ -5,5 +5,5 @@
 	supportsExtension( "terrainmod", "Terrain modification pseudo loader");
 
-	std::string extensionToAdd = ".terrainmod";
+	extensionToAdd = ".terrainmod";
 }
 
@@ -33,10 +33,21 @@
 
 	// Traverse through loaded graph, check for PagedLOD and modify all filenames of external references
+	// This ensures ensures that higher LODs are loaded via terrainmod pseudo loader as well.
 	ModificationVisitor modVisitor(extensionToAdd);
 	node->accept( modVisitor );
+
+	// Modify loaded terrain
+	ReaderWriterTerrainMod* this_unconst = const_cast < ReaderWriterTerrainMod* > (this);
+	this_unconst->modifyTerrain();
 
 	return node;
 }
 
+void ReaderWriterTerrainMod::modifyTerrain()
+{
+	// 
+	OpenThreads::Thread::microSleep( 500000 );
+}
+
 // Add ourself to the Registry to instantiate the reader/writer.
 REGISTER_OSGPLUGIN(terrainmod, ReaderWriterTerrainMod)
Index: /experimental/TerrainTest/ReaderWriterTerrainMod.h
===================================================================
--- /experimental/TerrainTest/ReaderWriterTerrainMod.h	(revision 252)
+++ /experimental/TerrainTest/ReaderWriterTerrainMod.h	(revision 253)
@@ -17,5 +17,6 @@
 	virtual ReadResult readNode( const std::string& file, const osgDB::ReaderWriter::Options* options) const;
 
-
-	//virtual ~ReaderWriterTerrainMod();
+private:
+	void modifyTerrain();
+	std::string extensionToAdd;
 };
Index: /experimental/TerrainTest/TerrainTest.sln
===================================================================
--- /experimental/TerrainTest/TerrainTest.sln	(revision 252)
+++ /experimental/TerrainTest/TerrainTest.sln	(revision 253)
@@ -1488,5 +1488,5 @@
 	EndProjectSection
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "Plugins terrainmod", "..\Plugins terrainmod\Plugins terrainmod.vcproj", "{59A20266-19E6-4ABD-A43A-6485BA7C1537}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "Plugins terrainmod", "Plugins terrainmod\Plugins terrainmod.vcproj", "{59A20266-19E6-4ABD-A43A-6485BA7C1537}"
 EndProject
 Global