Index: projectionDesigner/trunk/projdesigner/include/gui/qchannelwidget.ui
===================================================================
--- projectionDesigner/trunk/projdesigner/include/gui/qchannelwidget.ui	(revision 4)
+++ projectionDesigner/trunk/projdesigner/include/gui/qchannelwidget.ui	(revision 434)
@@ -1,6 +1,7 @@
-<ui version="4.0" >
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
  <class>QChannelWidget</class>
- <widget class="QWidget" name="QChannelWidget" >
-  <property name="geometry" >
+ <widget class="QWidget" name="QChannelWidget">
+  <property name="geometry">
    <rect>
     <x>0</x>
@@ -10,25 +11,25 @@
    </rect>
   </property>
-  <property name="windowTitle" >
+  <property name="windowTitle">
    <string>Channel Settings</string>
   </property>
-  <layout class="QVBoxLayout" >
-   <property name="spacing" >
+  <layout class="QVBoxLayout">
+   <property name="spacing">
     <number>6</number>
    </property>
-   <property name="margin" >
+   <property name="margin">
     <number>0</number>
    </property>
    <item>
-    <layout class="QHBoxLayout" >
-     <property name="spacing" >
+    <layout class="QHBoxLayout">
+     <property name="spacing">
       <number>6</number>
      </property>
-     <property name="margin" >
+     <property name="margin">
       <number>0</number>
      </property>
      <item>
-      <widget class="QLabel" name="nameLabel" >
-       <property name="text" >
+      <widget class="QLabel" name="nameLabel">
+       <property name="text">
         <string>Name</string>
        </property>
@@ -36,12 +37,12 @@
      </item>
      <item>
-      <widget class="QLineEdit" name="nameEdit" />
+      <widget class="QLineEdit" name="nameEdit"/>
      </item>
      <item>
       <spacer>
-       <property name="orientation" >
+       <property name="orientation">
         <enum>Qt::Horizontal</enum>
        </property>
-       <property name="sizeHint" stdset="0" >
+       <property name="sizeHint" stdset="0">
         <size>
          <width>40</width>
@@ -54,26 +55,26 @@
    </item>
    <item>
-    <widget class="QGroupBox" name="overlayGroupBox" >
-     <property name="title" >
+    <widget class="QGroupBox" name="overlayGroupBox">
+     <property name="title">
       <string>Overlay</string>
      </property>
-     <layout class="QHBoxLayout" >
-      <property name="spacing" >
+     <layout class="QHBoxLayout">
+      <property name="spacing">
        <number>6</number>
       </property>
-      <property name="margin" >
+      <property name="margin">
        <number>4</number>
       </property>
       <item>
-       <layout class="QVBoxLayout" >
-        <property name="spacing" >
+       <layout class="QVBoxLayout">
+        <property name="spacing">
          <number>6</number>
         </property>
-        <property name="margin" >
+        <property name="margin">
          <number>0</number>
         </property>
         <item>
-         <widget class="QCheckBox" name="overlayNameCheckBox" >
-          <property name="text" >
+         <widget class="QCheckBox" name="overlayNameCheckBox">
+          <property name="text">
            <string>Channel name</string>
           </property>
@@ -81,14 +82,14 @@
         </item>
         <item>
-         <layout class="QHBoxLayout" >
-          <property name="spacing" >
+         <layout class="QHBoxLayout">
+          <property name="spacing">
            <number>6</number>
           </property>
-          <property name="margin" >
+          <property name="margin">
            <number>0</number>
           </property>
           <item>
-           <widget class="QLabel" name="overlayImageLabel" >
-            <property name="text" >
+           <widget class="QLabel" name="overlayImageLabel">
+            <property name="text">
              <string>Image</string>
             </property>
@@ -96,7 +97,7 @@
           </item>
           <item>
-           <widget class="QLineEdit" name="overlayImageEdit" >
-            <property name="sizePolicy" >
-             <sizepolicy vsizetype="Fixed" hsizetype="MinimumExpanding" >
+           <widget class="QLineEdit" name="overlayImageEdit">
+            <property name="sizePolicy">
+             <sizepolicy hsizetype="MinimumExpanding" vsizetype="Fixed">
               <horstretch>0</horstretch>
               <verstretch>0</verstretch>
@@ -106,12 +107,12 @@
           </item>
           <item>
-           <widget class="QPushButton" name="overlayImageBrowseButton" >
-            <property name="sizePolicy" >
-             <sizepolicy vsizetype="Fixed" hsizetype="Fixed" >
+           <widget class="QPushButton" name="overlayImageBrowseButton">
+            <property name="sizePolicy">
+             <sizepolicy hsizetype="Fixed" vsizetype="Fixed">
               <horstretch>0</horstretch>
               <verstretch>0</verstretch>
              </sizepolicy>
             </property>
-            <property name="maximumSize" >
+            <property name="maximumSize">
              <size>
               <width>23</width>
@@ -119,5 +120,5 @@
              </size>
             </property>
-            <property name="text" >
+            <property name="text">
              <string>...</string>
             </property>
@@ -132,49 +133,49 @@
    </item>
    <item>
-    <widget class="QToolBox" name="toolBox" >
-     <property name="autoFillBackground" >
+    <widget class="QToolBox" name="toolBox">
+     <property name="autoFillBackground">
       <bool>true</bool>
      </property>
-     <property name="currentIndex" >
+     <property name="currentIndex">
       <number>1</number>
      </property>
-     <widget class="QWidget" name="page" >
-      <property name="geometry" >
+     <widget class="QWidget" name="page">
+      <property name="geometry">
        <rect>
         <x>0</x>
         <y>0</y>
-        <width>232</width>
-        <height>198</height>
+        <width>158</width>
+        <height>58</height>
        </rect>
       </property>
-      <attribute name="label" >
+      <attribute name="label">
        <string>Remote Settings</string>
       </attribute>
-      <layout class="QHBoxLayout" >
-       <property name="spacing" >
+      <layout class="QHBoxLayout">
+       <property name="spacing">
         <number>6</number>
        </property>
-       <property name="margin" >
+       <property name="margin">
         <number>0</number>
        </property>
        <item>
-        <layout class="QVBoxLayout" >
-         <property name="spacing" >
+        <layout class="QVBoxLayout">
+         <property name="spacing">
           <number>6</number>
          </property>
-         <property name="margin" >
+         <property name="margin">
           <number>0</number>
          </property>
          <item>
-          <layout class="QHBoxLayout" >
-           <property name="spacing" >
+          <layout class="QHBoxLayout">
+           <property name="spacing">
             <number>6</number>
            </property>
-           <property name="margin" >
+           <property name="margin">
             <number>0</number>
            </property>
            <item>
-            <widget class="QLabel" name="remoteHostNameLabel" >
-             <property name="text" >
+            <widget class="QLabel" name="remoteHostNameLabel">
+             <property name="text">
               <string>Host name</string>
              </property>
@@ -182,19 +183,19 @@
            </item>
            <item>
-            <widget class="QLineEdit" name="remoteHostNameEdit" />
+            <widget class="QLineEdit" name="remoteHostNameEdit"/>
            </item>
           </layout>
          </item>
          <item>
-          <layout class="QHBoxLayout" >
-           <property name="spacing" >
+          <layout class="QHBoxLayout">
+           <property name="spacing">
             <number>6</number>
            </property>
-           <property name="margin" >
+           <property name="margin">
             <number>0</number>
            </property>
            <item>
-            <widget class="QCheckBox" name="remoteFullScreenCheckBox" >
-             <property name="text" >
+            <widget class="QCheckBox" name="remoteFullScreenCheckBox">
+             <property name="text">
               <string>Full screen</string>
              </property>
@@ -202,6 +203,6 @@
            </item>
            <item>
-            <widget class="QLabel" name="remoteScreenLabel" >
-             <property name="text" >
+            <widget class="QLabel" name="remoteScreenLabel">
+             <property name="text">
               <string> Screen</string>
              </property>
@@ -209,22 +210,22 @@
            </item>
            <item>
-            <widget class="QComboBox" name="remoteScreenComboBox" >
+            <widget class="QComboBox" name="remoteScreenComboBox">
              <item>
-              <property name="text" >
+              <property name="text">
                <string>1</string>
               </property>
              </item>
              <item>
-              <property name="text" >
+              <property name="text">
                <string>2</string>
               </property>
              </item>
              <item>
-              <property name="text" >
+              <property name="text">
                <string>3</string>
               </property>
              </item>
              <item>
-              <property name="text" >
+              <property name="text">
                <string>4</string>
               </property>
@@ -236,8 +237,8 @@
          <item>
           <spacer>
-           <property name="orientation" >
+           <property name="orientation">
             <enum>Qt::Vertical</enum>
            </property>
-           <property name="sizeHint" stdset="0" >
+           <property name="sizeHint" stdset="0">
             <size>
              <width>20</width>
@@ -251,34 +252,34 @@
       </layout>
      </widget>
-     <widget class="QWidget" name="page_2" >
-      <property name="geometry" >
+     <widget class="QWidget" name="page_2">
+      <property name="geometry">
        <rect>
         <x>0</x>
         <y>0</y>
         <width>232</width>
-        <height>262</height>
+        <height>267</height>
        </rect>
       </property>
-      <attribute name="label" >
+      <attribute name="label">
        <string>Projector</string>
       </attribute>
-      <layout class="QVBoxLayout" >
-       <property name="spacing" >
+      <layout class="QVBoxLayout">
+       <property name="spacing">
         <number>0</number>
        </property>
-       <property name="margin" >
+       <property name="margin">
         <number>0</number>
        </property>
        <item>
-        <layout class="QHBoxLayout" >
-         <property name="spacing" >
+        <layout class="QHBoxLayout">
+         <property name="spacing">
           <number>6</number>
          </property>
-         <property name="margin" >
+         <property name="margin">
           <number>0</number>
          </property>
          <item>
-          <widget class="QLabel" name="pluginLabel" >
-           <property name="text" >
+          <widget class="QLabel" name="pluginLabel">
+           <property name="text">
             <string>Plugin</string>
            </property>
@@ -286,12 +287,12 @@
          </item>
          <item>
-          <widget class="QComboBox" name="pluginComboBox" />
+          <widget class="QComboBox" name="pluginComboBox"/>
          </item>
          <item>
           <spacer>
-           <property name="orientation" >
+           <property name="orientation">
             <enum>Qt::Horizontal</enum>
            </property>
-           <property name="sizeHint" stdset="0" >
+           <property name="sizeHint" stdset="0">
             <size>
              <width>40</width>
@@ -304,6 +305,6 @@
        </item>
        <item>
-        <widget class="QStackedWidget" name="stackedWidget" >
-         <property name="minimumSize" >
+        <widget class="QStackedWidget" name="stackedWidget">
+         <property name="minimumSize">
           <size>
            <width>0</width>
@@ -314,6 +315,6 @@
        </item>
        <item>
-        <widget class="projection::QTransformMatrixWidget" native="1" name="projectionTransformWidget" >
-         <property name="focusPolicy" >
+        <widget class="projection::QTransformMatrixWidget" name="projectionTransformWidget" native="true">
+         <property name="focusPolicy">
           <enum>Qt::StrongFocus</enum>
          </property>
@@ -321,26 +322,26 @@
        </item>
        <item>
-        <widget class="QGroupBox" name="warpGroupBox" >
-         <property name="title" >
+        <widget class="QGroupBox" name="warpGroupBox">
+         <property name="title">
           <string>Warp</string>
          </property>
-         <layout class="QHBoxLayout" >
-          <property name="spacing" >
+         <layout class="QHBoxLayout">
+          <property name="spacing">
            <number>6</number>
           </property>
-          <property name="margin" >
+          <property name="margin">
            <number>4</number>
           </property>
           <item>
-           <layout class="QHBoxLayout" >
-            <property name="spacing" >
+           <layout class="QHBoxLayout">
+            <property name="spacing">
              <number>6</number>
             </property>
-            <property name="margin" >
+            <property name="margin">
              <number>0</number>
             </property>
             <item>
-             <widget class="QCheckBox" name="warpCheckBox" >
-              <property name="text" >
+             <widget class="QCheckBox" name="warpCheckBox">
+              <property name="text">
                <string>Enable</string>
               </property>
@@ -348,6 +349,6 @@
             </item>
             <item>
-             <widget class="QLabel" name="warpResLabel" >
-              <property name="text" >
+             <widget class="QLabel" name="warpResLabel">
+              <property name="text">
                <string>Res.</string>
               </property>
@@ -355,6 +356,6 @@
             </item>
             <item>
-             <widget class="QSpinBox" name="warpResSpinBox" >
-              <property name="maximumSize" >
+             <widget class="QSpinBox" name="warpResSpinBox">
+              <property name="maximumSize">
                <size>
                 <width>32</width>
@@ -362,8 +363,8 @@
                </size>
               </property>
-              <property name="minimum" >
+              <property name="minimum">
                <number>2</number>
               </property>
-              <property name="maximum" >
+              <property name="maximum">
                <number>8</number>
               </property>
@@ -371,6 +372,6 @@
             </item>
             <item>
-             <widget class="QPushButton" name="warpResetButton" >
-              <property name="maximumSize" >
+             <widget class="QPushButton" name="warpResetButton">
+              <property name="maximumSize">
                <size>
                 <width>50</width>
@@ -378,5 +379,5 @@
                </size>
               </property>
-              <property name="text" >
+              <property name="text">
                <string>Reset</string>
               </property>
@@ -389,17 +390,17 @@
        </item>
        <item>
-        <layout class="QHBoxLayout" >
-         <property name="spacing" >
+        <layout class="QHBoxLayout">
+         <property name="spacing">
           <number>0</number>
          </property>
-         <property name="margin" >
+         <property name="margin">
           <number>0</number>
          </property>
          <item>
           <spacer>
-           <property name="orientation" >
+           <property name="orientation">
             <enum>Qt::Horizontal</enum>
            </property>
-           <property name="sizeHint" stdset="0" >
+           <property name="sizeHint" stdset="0">
             <size>
              <width>40</width>
@@ -410,9 +411,9 @@
          </item>
          <item>
-          <widget class="QPushButton" name="calibrateButton" >
-           <property name="enabled" >
+          <widget class="QPushButton" name="calibrateButton">
+           <property name="enabled">
             <bool>false</bool>
            </property>
-           <property name="text" >
+           <property name="text">
             <string>Calibrate...</string>
            </property>
@@ -423,8 +424,8 @@
        <item>
         <spacer>
-         <property name="orientation" >
+         <property name="orientation">
           <enum>Qt::Vertical</enum>
          </property>
-         <property name="sizeHint" stdset="0" >
+         <property name="sizeHint" stdset="0">
           <size>
            <width>20</width>
@@ -436,34 +437,34 @@
       </layout>
      </widget>
-     <widget class="QWidget" name="page_3" >
-      <property name="geometry" >
+     <widget class="QWidget" name="page_3">
+      <property name="geometry">
        <rect>
         <x>0</x>
         <y>0</y>
-        <width>232</width>
-        <height>349</height>
+        <width>98</width>
+        <height>28</height>
        </rect>
       </property>
-      <attribute name="label" >
+      <attribute name="label">
        <string>View</string>
       </attribute>
-      <layout class="QVBoxLayout" >
-       <property name="spacing" >
+      <layout class="QVBoxLayout">
+       <property name="spacing">
         <number>0</number>
        </property>
-       <property name="margin" >
+       <property name="margin">
         <number>0</number>
        </property>
        <item>
-        <layout class="QVBoxLayout" >
-         <property name="spacing" >
+        <layout class="QVBoxLayout">
+         <property name="spacing">
           <number>0</number>
          </property>
-         <property name="margin" >
+         <property name="margin">
           <number>0</number>
          </property>
          <item>
-          <widget class="projection::QProjectionMatrixWidget" native="1" name="viewProjectionWidget" >
-           <property name="focusPolicy" >
+          <widget class="projection::QProjectionMatrixWidget" name="viewProjectionWidget" native="true">
+           <property name="focusPolicy">
             <enum>Qt::StrongFocus</enum>
            </property>
@@ -471,6 +472,6 @@
          </item>
          <item>
-          <widget class="projection::QTransformMatrixWidget" native="1" name="viewTransformWidget" >
-           <property name="focusPolicy" >
+          <widget class="projection::QTransformMatrixWidget" name="viewTransformWidget" native="true">
+           <property name="focusPolicy">
             <enum>Qt::StrongFocus</enum>
            </property>
@@ -478,17 +479,17 @@
          </item>
          <item>
-          <layout class="QHBoxLayout" >
-           <property name="spacing" >
+          <layout class="QHBoxLayout">
+           <property name="spacing">
             <number>0</number>
            </property>
-           <property name="margin" >
+           <property name="margin">
             <number>0</number>
            </property>
            <item>
             <spacer>
-             <property name="orientation" >
+             <property name="orientation">
               <enum>Qt::Horizontal</enum>
              </property>
-             <property name="sizeHint" stdset="0" >
+             <property name="sizeHint" stdset="0">
               <size>
                <width>40</width>
@@ -499,9 +500,9 @@
            </item>
            <item>
-            <widget class="QPushButton" name="fitButton" >
-             <property name="enabled" >
+            <widget class="QPushButton" name="fitButton">
+             <property name="enabled">
               <bool>false</bool>
              </property>
-             <property name="text" >
+             <property name="text">
               <string>Fit to Projector</string>
              </property>
@@ -512,8 +513,8 @@
          <item>
           <spacer>
-           <property name="orientation" >
+           <property name="orientation">
             <enum>Qt::Vertical</enum>
            </property>
-           <property name="sizeHint" stdset="0" >
+           <property name="sizeHint" stdset="0">
             <size>
              <width>20</width>
@@ -531,11 +532,11 @@
    <item>
     <spacer>
-     <property name="orientation" >
+     <property name="orientation">
       <enum>Qt::Vertical</enum>
      </property>
-     <property name="sizeType" >
+     <property name="sizeType">
       <enum>QSizePolicy::Fixed</enum>
      </property>
-     <property name="sizeHint" stdset="0" >
+     <property name="sizeHint" stdset="0">
       <size>
        <width>190</width>
@@ -546,17 +547,17 @@
    </item>
    <item>
-    <layout class="QHBoxLayout" >
-     <property name="spacing" >
+    <layout class="QHBoxLayout">
+     <property name="spacing">
       <number>6</number>
      </property>
-     <property name="margin" >
+     <property name="margin">
       <number>0</number>
      </property>
      <item>
       <spacer>
-       <property name="orientation" >
+       <property name="orientation">
         <enum>Qt::Horizontal</enum>
        </property>
-       <property name="sizeHint" stdset="0" >
+       <property name="sizeHint" stdset="0">
         <size>
          <width>40</width>
@@ -567,15 +568,15 @@
      </item>
      <item>
-      <widget class="QPushButton" name="windowButton" >
-       <property name="sizePolicy" >
-        <sizepolicy vsizetype="Fixed" hsizetype="Minimum" >
+      <widget class="QPushButton" name="windowButton">
+       <property name="sizePolicy">
+        <sizepolicy hsizetype="Minimum" vsizetype="Fixed">
          <horstretch>0</horstretch>
          <verstretch>0</verstretch>
         </sizepolicy>
        </property>
-       <property name="focusPolicy" >
+       <property name="focusPolicy">
         <enum>Qt::NoFocus</enum>
        </property>
-       <property name="text" >
+       <property name="text">
         <string>Open Window...</string>
        </property>